package com.hnj.usb_lableprintdemo;

import androidx.appcompat.app.AppCompatActivity;
import java.io.IOException;
import java.io.InputStream;

import com.hnj.dp_nusblist.USBFactory;

import android.app.Activity;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class LablePrintActivity extends AppCompatActivity {

    private Button bt_text,bt_barcode,bt_qr,bt_image,bt_cuttall,bt_cutting,bt_textimage,bt_printdemo1,bt_printdemo2,bt_lableprint;
    private USBFactory usbfactory;
    private TextView title_tv;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        // TODO Auto-generated method stub
        super.onCreate(savedInstanceState);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.activity_lable_print);
        usbfactory=MainActivity.usbUtil.GetUSBFactory();
        bt_text=(Button)findViewById(R.id.bt_text);
        title_tv=(TextView)findViewById(R.id.title_tv);
        bt_barcode=(Button)findViewById(R.id.bt_barcode);
        bt_qr=(Button)findViewById(R.id.bt_qr);
        bt_image=(Button)findViewById(R.id.bt_image);
        bt_cuttall=(Button)findViewById(R.id.bt_cuttall);
        bt_cutting=(Button)findViewById(R.id.bt_cutting);
        bt_textimage=(Button)findViewById(R.id.bt_textimage);
        bt_lableprint=(Button)findViewById(R.id.bt_lableprint);
        bt_printdemo1=(Button)findViewById(R.id.bt_printdemo1);
        bt_printdemo2=(Button)findViewById(R.id.bt_printdemo2);
        title_tv.setText("标签测试打印");

        //打印文本
        bt_text.setOnClickListener(new OnClickListener() {
            @SuppressWarnings("static-access")
            @Override
            public void onClick(View arg0) {
                /**
                 * LableText 标签文本打印 宽度计算方式
                 * 384*0.125=48mm 这个是有效宽度打印范围，
                 * 240*0.125=30mm 这个是有效高度打印范围，
                 * 第一个参数  X轴横向位移量
                 * 第二个参数  Y轴纵向位移量
                 * 第三个参数  字体大小 有效值1-6
                 * 第四个参数   是否旋转 0不旋转，1旋转90°
                 * 第五个参数   文本内容
                 */
                usbfactory.LabelBegin(576, 240);//先设置标签的宽度和高度
                usbfactory.LableText(0, 5, 1, 0, "1正常字体大小");
                usbfactory.LableText(0, 30, 2, 0, "2字体放大2倍");
                usbfactory.LableText(0, 80, 3, 0, "3倍字体放大3倍");
                usbfactory.LableText(0, 140, 4, 0, "4倍字体放大4倍");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印

                /**
                 * LableText 标签文本打印
                 * 第一个参数  X轴横向位移量
                 * 第二个参数  Y轴纵向位移量
                 * 第三个参数  字体大小 有效值1-6
                 * 第四个参数   是否旋转 0不旋转，1旋转90°
                 * 第五个参数   文本加粗0不加粗，1加粗字体
                 * 第六个参数   文本内容
                 */
                usbfactory.LabelBegin(576, 240);//先设置标签的宽度和高度
                usbfactory.LableText(0, 5, 1,1, 0, "1旋转90°");
                usbfactory.LableText(90, 30, 1, 0, "正常字体大小");
                usbfactory.LableText(60, 30, 1,1,0,"正常字体加粗");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印

                usbfactory.PaperCut();
            }
        });

//		打印条码
        bt_barcode.setOnClickListener(new OnClickListener() {
            @SuppressWarnings("static-access")
            @Override
            public void onClick(View arg0) {
                /**
                 * LableBarcode 标签条形码打印
                 * 第一个参数  X轴横向位移量
                 * 第二个参数  Y轴纵向位移量
                 * 第三个参数  条码高度 有效值10-200
                 * 第四个参数   条码线条宽度，1-4
                 * 第五个参数  是否旋转 0不旋转，1旋转90°
                 * 第六个参数   条码文本内容，不能包含有中文字符。
                 */
                usbfactory.LabelBegin(576, 240);//先设置标签的宽度和高度
                usbfactory.LableText(100, 145, 0, 0, "abfc-12345654645");
                usbfactory.LableBarcode(20, 55, 82, 2, 0, "abfc-12345654645");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印
                usbfactory.LabelBegin(384, 240);//先设置标签的宽度和高度
                usbfactory.LableText(130, 25, 1, 1, "abfc12");
                usbfactory.LableBarcode(155, 10, 82, 2, 1, "abfc12");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印
                usbfactory.PaperCut();
            }
        });
        //打印二维码
        bt_qr.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {


                /**
                 * LabelQRCode 标签二维码打印
                 * 第一个参数  X轴横向位移量
                 * 第二个参数  Y轴纵向位移量
                 * 第三个参数  二维码大小 有效值2-8
                 * 第四个参数   二维码文本内容
                 */
                usbfactory.LabelBegin(576, 240);//先设置标签打印范围的宽度和高度		56*30标签纸
                usbfactory.LabelQRCode(50, 5, 5,"中国深圳");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印

                /**
                 * LabelQRCode 标签二维码打印
                 * 第一个参数  X轴横向位移量
                 * 第二个参数  Y轴纵向位移量
                 * 第三个参数  版本号1-18，数字越大二维码越密集，二维码呈现内容就越多。
                 * 第四个参数   二维码大小 有效值2-8
                 *  第5个参数   二维码文本内容
                 */
                usbfactory.LabelBegin(576, 240);
                usbfactory.LabelQRCode(90, 10,14, 3,"abc123");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印

                usbfactory.PaperCut();

            }
        });
//		打印图片
        bt_image.setOnClickListener(new OnClickListener() {
            @SuppressWarnings("static-access")
            @Override
            public void onClick(View arg0) {
                /**
                 * LableImage 标签图片打印
                 * 第一个参数  X轴横向位移量
                 * 第二个参数  Y轴纵向位移量
                 * 第三个参数  图片大小最大范围不能超过标签纸的宽度,如果图片是800*400打印机会做等比例缩放处理到要打印图片的大小
                 * 第四个参数   bitmap图片
                 */
                Bitmap bm = getImageFromAssetsFile("1.jpg");
                if (null != bm) {
                    usbfactory.LabelBegin(384,250);//先设置标签的宽度和高度	56*30标签纸
                    usbfactory.LableImage(0, 0, 384, bm);
                    usbfactory.Labelend();//必须要有标签结束，否则不会打印
					usbfactory.PaperCut();
                }else {
                    Toast_Util.ToastString(getApplicationContext(), R.string.no_printed_pictures);//没有打印图片
                }
            }
        });


        bt_textimage.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                /** LableTextImage 文本图片标签打印，是将文本内容转换成图片再打印。打印速度会慢一些，适应各种字体大小设计需求。
                 //第一个参数  X轴横向位移量
                 //第二个参数  Y轴纵向位移量
                 //第三个参数    打印图片宽度
                 //第四个参数    字体大小
                 //第五个参数    生成图片文本内容
                 */
                usbfactory.LabelBegin(576, 240);//先设置标签的宽度和高度	56*30标签纸
                usbfactory.LableTextImage(0, 0, 200, 30, "中国人民");
                usbfactory.LableTextImage(0, 30, 200, 40,"中国人民");
                usbfactory.LableTextImage(0, 80, 200, 50,"中国人民");
                usbfactory.LableTextImage(0, 130, 384, 95,"中国人民");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印
                usbfactory.PaperCut();
            }
        });
        bt_cutting.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                usbfactory.PaperCut();//半切
            }
        });
        bt_cuttall.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                usbfactory.PaperAllCut();//全切
            }
        });

        bt_printdemo1.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                //两寸标签打印示例
                usbfactory.LabelBegin(384, 240);//先设置标签的宽度和高度	56*30标签纸
                usbfactory.LableText(0,5,2,0,"极速达物流");
                usbfactory.LableText(290,5,2,0,"电子");
                usbfactory.LableText(10,140,2,0,"广州-->");
                usbfactory.LableText(290,140,2,0,"汽运");
                usbfactory.LableText(10,200,1,0,"厦门");
                usbfactory.LableBarcode(40,65,65, 3, 0, "123456789586");
                usbfactory.LableText(265,200,1,0,"2018-08-18");
                usbfactory.Labelend();//必须要有标签结束，否则不会打印
                usbfactory.PaperCut();//半切
                demo3();

            }
        });
        bt_lableprint.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                testdemo1();
            }
        });
        bt_printdemo2.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                //三寸标签打印示例
//				demo4();
                demo5();
            }
        });
    }


    private void demo3()
    {
        usbfactory.LabelBegin(384, 230);//先设置标签的宽度和高度	56*30标签纸
        usbfactory.LabelQRCode(0, 25,5,"电 池");
        usbfactory.LableText(200,10,1,0,"MC 1001");
        usbfactory.LableText(200,40,1,0,"电 池");
        usbfactory.LableText(200,70,1,0,"2018-8-18");
        usbfactory.LableText(200,100,1,0,"18:18:18");
        usbfactory.LableText(200,130,1,0,"STCP00000369");
        usbfactory.LableText(200,160, 1, 0, "2018-8-28前有效");
        usbfactory.LableText(200,190,1,0,"LS 32006");
        usbfactory.Labelend();//必须要有标签结束，否则不会打印
        usbfactory.PaperCut();
    }

    private void demo4()
    {

        usbfactory.LabelBegin(576, 330,2);//2 参数是标签选择180°倒打
        usbfactory.LableText(5, 0, 1, 0,  "样品编号:1765");
        usbfactory.LableText(5, 26, 1, 0, "样品名称:芹菜" );
        usbfactory.LableText(5, 52, 1, 0, "样品来源:张三家大鹏蔬菜" );
        usbfactory.LableText(5, 78, 1, 0, "生产档案号:TS56981" );
        usbfactory.LableText(5, 104, 1, 0, "检测单位:河南赛孚特农产" );
        usbfactory.LableText(5, 130, 1, 0, "品质量检测服务有限公司" );
        usbfactory.LableText(5, 156, 1, 0, "检测员:张涵" );
        usbfactory.LableText(5, 182, 1, 0, "抑制率:4,636.00%" );
        usbfactory.LableText(5, 208, 1, 0, "检测结果:合格" );
        usbfactory.LableText(5, 234, 1, 0, "检测日期:2020-04-07 11:23:50");
        Bitmap bitmap = QRCodeUtil.createQRCodeBitmap("样品编号:1765|样品名称:芹菜|样品来源:张三家大鹏蔬菜|"
                + "生产档案号:TS56981|检测单位:河南赛孚特农产品质量检测服务有限公司",255,255);//二维码固定大小或设置任意大小可以使用图片方式打印二维码
        usbfactory.LableImage(330,  0,255,bitmap);
        usbfactory.PrintBlankLine();
        usbfactory.PrintBlankLine();
        usbfactory.PrintBlankLine();
        usbfactory.PrintBlankLine();
        usbfactory.Labelend();//必须要有标签结束，否则不会打印
        usbfactory.PaperAllCut();

    }


    private void demo5()
    {

        usbfactory.LabelBegin(576, 330);//正常打印
        usbfactory.LableText(5, 10, 1, 0,  "样品编号:1765");
        usbfactory.LableText(5, 36, 1, 0, "样品名称:芹菜" );
        usbfactory.LableText(5, 62, 1, 0, "样品来源:张三家大鹏蔬菜" );
        usbfactory.LableText(5, 88, 1, 0, "生产档案号:TS56981" );
        usbfactory.LableText(5, 114, 1, 0, "检测单位:河南赛孚特农产" );
        usbfactory.LableText(5, 140, 1, 0, "品质量检测服务有限公司" );
        usbfactory.LableText(5, 166, 1, 0, "检测员:张涵" );
        usbfactory.LableText(5, 192, 1, 0, "抑制率:4,636.00%" );
        usbfactory.LableText(5, 218, 1, 0, "检测结果:合格" );
        usbfactory.LableText(5, 244, 1, 0, "检测日期:2020-04-07 11:23:50");
        usbfactory.LabelQRCode(360, 45, 5,"60705945");//正常打印二维方法
        usbfactory.Labelend();//必须要有标签结束，否则不会打印
        usbfactory.PaperAllCut();

    }

    private void testdemo1()
    {
        int t=20;
        Bitmap bm = getImageFromAssetsFile("61.jpg");
        usbfactory.LabelBegin(576, 350);//正常打印
        usbfactory.LableImage(0, 10, 100, bm);
        usbfactory.LableText(115, 30, 2, 0,  "黄登打印纸");
        usbfactory.LableText(5, 100+t, 1, 0,  "采购订单:1765");
        usbfactory.LableText(5, 130+t, 1, 0, "物资编号：P010235485" );
        usbfactory.LableText(5, 160+t, 1, 0, "批    次：10012" );
        usbfactory.LableText(5, 190+t, 1, 0, "特殊库存:TS56981" );
        usbfactory.LableText(5, 220+t, 1, 0, "库存地点:锅炉备品库物资仓库" );
        usbfactory.LableText(5, 250+t, 1, 0, "物资描述:安全阀备件\\阀芯\\S85-7078" );
        usbfactory.LableText(120, 280+t, 1, 0, "ASYMB667-7718" );
        usbfactory.LabelQRCode(400, 25, 5,"ID:1765");//正常打印二维方法
        usbfactory.Labelend();//必须要有标签结束，否则不会打印
        usbfactory.PaperAllCut();
    }


    /**
     * 打印测试页面
     * @param v
     */
    public void printtestpage(View v)
    {
        usbfactory.PrintTestPage();
    }

    /**
     * 检查缺纸
     *
     */
    @SuppressWarnings("static-access")
    public void checkpage(View v)
    {

        if(MainActivity.Paperstate)
        {
            Toast_Util.ToastString(getApplicationContext(), R.string.printer_have_paper);
        }else {
            Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
        }
    }

    /**
     * 从Assets中读取图片
     */
    private Bitmap getImageFromAssetsFile(String fileName) {
        Bitmap image = null;
        AssetManager am = getResources().getAssets();
        try {
            InputStream is = am.open(fileName);
            image = BitmapFactory.decodeStream(is);
            is.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return image;

    }

    public void back(View v)
    {
        finish();
    }

}